//+------------------------------------------------------------------+
//|                                               Test2_Modes_EA.mq5 |
//|                                           Copyright 2014, denkir |
//|                           https://login.mql5.com/ru/users/denkir |
//+------------------------------------------------------------------+
#property copyright "Copyright 2014, denkir"
#property link      "https://login.mql5.com/ru/users/denkir"
#property version   "1.00"
//+------------------------------------------------------------------+
//| MQL-                                                        |
//+------------------------------------------------------------------+
enum ENUM_MQL_MODE
  {
   MQL_MODE_RELEASE=0,       // 
   MQL_MODE_DEBUG=1,         // 
   MQL_MODE_PROFILER=2,      //   
   MQL_MODE_TESTER=3,        // 
   MQL_MODE_OPTIMIZATION=4,  // 
   MQL_MODE_VISUAL=5,        //   
   MQL_MODE_FRAME=6,         //  
  };
//+------------------------------------------------------------------+
//| Inputs                                                           |
//+------------------------------------------------------------------+
input ENUM_MQL_MODE InpMqlMode=6;       // 
input int InpStopLoss=150;              // -,
input bool InpIsLogging=true;           //   ?

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
   if(InpIsLogging)
     {
      Print("\n : "+EnumToString(InpMqlMode));
      ENUM_MQL_MODE curr_mode=MqlMode();
      Print(" : "+EnumToString(curr_mode));
     }
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {


  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---

  }
//+------------------------------------------------------------------+
//| Tester function                                                  |
//+------------------------------------------------------------------+
double OnTester()
  {
//---
   double ret=0.0;
//---

//---
   return(ret);
  }
//+------------------------------------------------------------------+
//| TesterInit function                                              |
//+------------------------------------------------------------------+
void OnTesterInit()
  {
   if(InpIsLogging)
     {
      Print("\n : "+EnumToString(InpMqlMode));
      ENUM_MQL_MODE curr_mode=MqlMode();
      Print(" : "+EnumToString(curr_mode));
     }
  }
//+------------------------------------------------------------------+
//| TesterPass function                                              |
//+------------------------------------------------------------------+
void OnTesterPass()
  {
   if(InpIsLogging)
     {
      Print("\n : "+EnumToString(InpMqlMode));
      ENUM_MQL_MODE curr_mode=MqlMode();
      Print(" : "+EnumToString(curr_mode));
     }
  }
//+------------------------------------------------------------------+
//| TesterDeinit function                                            |
//+------------------------------------------------------------------+
void OnTesterDeinit()
  {
   if(InpIsLogging)
     {
      Print("\n : "+EnumToString(InpMqlMode));
      ENUM_MQL_MODE curr_mode=MqlMode();
      Print(" : "+EnumToString(curr_mode));
     }
  }
//+------------------------------------------------------------------+
//|   MQL-                                     |
//+------------------------------------------------------------------+
ENUM_MQL_MODE MqlMode(void)
  {
   ENUM_MQL_MODE curr_mode=WRONG_VALUE;

//---   
   if(MQLInfoInteger(MQL_DEBUG))
      curr_mode=MQL_MODE_DEBUG;
//---    
   else if(MQLInfoInteger(MQL_PROFILER))
      curr_mode=MQL_MODE_PROFILER;
//---    
   else if(MQLInfoInteger(MQL_VISUAL_MODE))
      curr_mode=MQL_MODE_VISUAL;
//---   
   else if(MQLInfoInteger(MQL_OPTIMIZATION))
      curr_mode=MQL_MODE_OPTIMIZATION;
//---   
   else if(MQLInfoInteger(MQL_TESTER))
      curr_mode=MQL_MODE_TESTER;
//---      
   else if(MQLInfoInteger(MQL_FRAME_MODE))
      curr_mode=MQL_MODE_FRAME;
//---  -
   else
      curr_mode=MQL_MODE_RELEASE;

//---
   return curr_mode;
  }

